Package com.smartgwt.client.widgets.calendar

# Class CalendarEvent

java.lang.Object
com.smartgwt.client.core.JsObject
com.smartgwt.client.core.DataClass
com.smartgwt.client.core.RefDataClass
com.smartgwt.client.data.Record
com.smartgwt.client.widgets.calendar.CalendarEvent

All Implemented Interfaces:
  `HasHandlers`

public class CalendarEvent extends Record
A type of `Record` which represents an event to occur at a specific time, displayed within the calendar.

See Also:
  - `Data overview and related methods`

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.core.RefDataClass

  `id`

  ### Fields inherited from class com.smartgwt.client.core.DataClass

  `factoryCreated, factoryProperties`

  ### Fields inherited from class com.smartgwt.client.core.JsObject

  `jsObj`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CalendarEvent()`
  `CalendarEvent(int eventId, String name, String description, Date startDate, int duration, TimeUnit durationUnit)`
  `CalendarEvent(int eventId, String name, String description, Date startDate, int duration, TimeUnit durationUnit, String styleName)`
  `CalendarEvent(int eventId, String name, String description, Date startDate, int duration, TimeUnit durationUnit, String styleName, String lane)`
  `CalendarEvent(int eventId, String name, String description, Date startDate, int duration, TimeUnit durationUnit, String styleName, String lane, String sublane)`
  `CalendarEvent(int eventId, String name, String description, Date startDate, Date endDate)`
  `CalendarEvent(int eventId, String name, String description, Date startDate, Date endDate, boolean canEdit)`
  `CalendarEvent(int eventId, String name, String description, Date startDate, Date endDate, boolean canEdit, String eventWindowStyle)`
  `CalendarEvent(int eventId, String name, String description, Date startDate, Date endDate, boolean canEdit, String eventWindowStyle, String lane)`
  `CalendarEvent(int eventId, String name, String description, Date startDate, Date endDate, boolean canEdit, String eventWindowStyle, String lane, String sublane)`
  `CalendarEvent(int eventId, String name, String description, Date startDate, Date endDate, String lane)`
  `CalendarEvent(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getBackgroundColor()`
  An optional background color for the body portion of `canvases` representing this event in the various `calendar views`.
  `String`
  `getBorderColor()`
  An optional border color for the body portion of `canvases` representing this event in the various `calendar views`.
  `Boolean`
  `getCanDrag()`
  Optional boolean value controlling whether this event can be dragged with the mouse.
  `Boolean`
  `getCanEdit()`
  Optional boolean value controlling the editability of this particular calendarEvent.
  `Boolean`
  `getCanEditLane()`
  Boolean indicating whether this event can be moved between lanes.
  `Boolean`
  `getCanEditSublane()`
  Boolean indicating whether this event can be moved between lanes.
  `Boolean`
  `getCanResize()`
  Optional boolean value controlling whether this event can be drag-resized with the mouse.
  `String`
  `getDescription()`
  String which represents the description of a `CalendarEvent` The name of this field within the CalendarEvent can be changed via `Calendar.descriptionField`
  `Boolean`
  `getDisabled()`
  For a CalendarEvent that represents a `styled zone`, this attribute causes date-cells behind this zone to be disabled, meaning that events cannot be created or moved there with the mouse.
  `Integer`
  `getDuration()`
  The duration of this event.
  `TimeUnit`
  `getDurationUnit()`
  When a `duration` is set for this event, this is the unit of that duration.
  `Date`
  `getEndDate()`
  Date object which represents the end date of a `CalendarEvent` The name of this field within the CalendarEvent can be changed via `Calendar.endDateField`
  `Integer`
  `getEventId()`
  `String`
  `getEventWindowStyle()`
  Deprecated.
  in favor of `styleName`
  `String`
  `getHeaderBackgroundColor()`
  An optional background color for the header portion of `canvases` representing this event in the various `calendar views`.
  `String`
  `getHeaderBorderColor()`
  An optional border color for the header portion of `canvases` representing this event in the various `calendar views`.
  `String`
  `getHeaderTextColor()`
  An optional text color for the header portion of `canvases` representing this event in the various `calendar views`.
  `String`
  `getLane()`
  When in Timeline mode, or when `Calendar.showDayLanes` is true, a string that represents the name of the `lane` this `CalendarEvent` should sit in.
  `String`
  `getName()`
  String which represents the name of a `CalendarEvent` The name of this field within the CalendarEvent can be changed via `Calendar.nameField`
  `static CalendarEvent`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `Date`
  `getStartDate()`
  Date object which represents the start date of a `CalendarEvent`.
  `String`
  `getStyleName()`
  CSS style series to use for `canvas instances` that represent this event in the various `calendar views`.
  `String`
  `getSublane()`
  When in Timeline mode, or when `Calendar.showDayLanes` is true, a string that represents the name of the `sublane` this `CalendarEvent` should sit in.
  `String`
  `getTextColor()`
  An optional text color for the body portion of `canvases` representing this event in the various `calendar views`.
  `Boolean`
  `getUseLogicalTimes()`
  For a CalendarEvent that represents a `styled zone`, this attribute causes the Calendar to always display this zone at its specified logical-times, irrespective of the current day-range.
  `CalendarEvent`
  `setBackgroundColor(String backgroundColor)`
  An optional background color for the body portion of `canvases` representing this event in the various `calendar views`.
  `CalendarEvent`
  `setBorderColor(String borderColor)`
  An optional border color for the body portion of `canvases` representing this event in the various `calendar views`.
  `CalendarEvent`
  `setCanDrag(Boolean canDrag)`
  Optional boolean value controlling whether this event can be dragged with the mouse.
  `void`
  `setCanEdit(Boolean canEdit)`
  Optional boolean value controlling the editability of this particular calendarEvent.
  `CalendarEvent`
  `setCanEditLane(Boolean canEditLane)`
  Boolean indicating whether this event can be moved between lanes.
  `CalendarEvent`
  `setCanEditSublane(Boolean canEditSublane)`
  Boolean indicating whether this event can be moved between lanes.
  `CalendarEvent`
  `setCanResize(Boolean canResize)`
  Optional boolean value controlling whether this event can be drag-resized with the mouse.
  `CalendarEvent`
  `setDescription(String description)`
  String which represents the description of a `CalendarEvent` The name of this field within the CalendarEvent can be changed via `Calendar.descriptionField`
  `CalendarEvent`
  `setDisabled(Boolean disabled)`
  For a CalendarEvent that represents a `styled zone`, this attribute causes date-cells behind this zone to be disabled, meaning that events cannot be created or moved there with the mouse.
  `CalendarEvent`
  `setDuration(Integer duration)`
  The duration of this event.
  `CalendarEvent`
  `setDurationUnit(TimeUnit durationUnit)`
  When a `duration` is set for this event, this is the unit of that duration.
  `CalendarEvent`
  `setEndDate(Date endDate)`
  Date object which represents the end date of a `CalendarEvent` The name of this field within the CalendarEvent can be changed via `Calendar.endDateField`
  `void`
  `setEventId(Integer eventId)`
  `CalendarEvent`
  `setEventWindowStyle(String eventWindowStyle)`
  Deprecated.
  in favor of `styleName`
  `CalendarEvent`
  `setHeaderBackgroundColor(String headerBackgroundColor)`
  An optional background color for the header portion of `canvases` representing this event in the various `calendar views`.
  `CalendarEvent`
  `setHeaderBorderColor(String headerBorderColor)`
  An optional border color for the header portion of `canvases` representing this event in the various `calendar views`.
  `CalendarEvent`
  `setHeaderTextColor(String headerTextColor)`
  An optional text color for the header portion of `canvases` representing this event in the various `calendar views`.
  `CalendarEvent`
  `setLane(String lane)`
  When in Timeline mode, or when `Calendar.showDayLanes` is true, a string that represents the name of the `lane` this `CalendarEvent` should sit in.
  `CalendarEvent`
  `setName(String name)`
  String which represents the name of a `CalendarEvent` The name of this field within the CalendarEvent can be changed via `Calendar.nameField`
  `CalendarEvent`
  `setStartDate(Date startDate)`
  Date object which represents the start date of a `CalendarEvent`.
  `CalendarEvent`
  `setStyleName(String styleName)`
  CSS style series to use for `canvas instances` that represent this event in the various `calendar views`.
  `CalendarEvent`
  `setSublane(String sublane)`
  When in Timeline mode, or when `Calendar.showDayLanes` is true, a string that represents the name of the `sublane` this `CalendarEvent` should sit in.
  `CalendarEvent`
  `setTextColor(String textColor)`
  An optional text color for the body portion of `canvases` representing this event in the various `calendar views`.
  `CalendarEvent`
  `setUseLogicalTimes(Boolean useLogicalTimes)`
  For a CalendarEvent that represents a `styled zone`, this attribute causes the Calendar to always display this zone at its specified logical-times, irrespective of the current day-range.

  ### Methods inherited from class com.smartgwt.client.data.Record

  `convertToRecordArray, copyAttributes, copyAttributesInto, getAttributeAsRecordArray, getAttributeAsRecordList, getPaletteDefaults, isARecord, toMap`

  ### Methods inherited from class com.smartgwt.client.core.RefDataClass

  `getRef, getRef, internalSetID`

  ### Methods inherited from class com.smartgwt.client.core.DataClass

  `applyFactoryProperties, doAddHandler, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsDoubleArray, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAttributes, getHandlerCount, isFactoryCreated, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject, setFactoryCreated`

  ### Methods inherited from class com.smartgwt.client.core.JsObject

  `equals, getJsObj, hashCode, isCreated, setJavaScriptObject, setJsObj`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### CalendarEvent

    public CalendarEvent()

  - ### CalendarEvent

    public CalendarEvent(JavaScriptObject jsObj)

  - ### CalendarEvent

    public CalendarEvent(int eventId, String name, String description, Date startDate, Date endDate)

  - ### CalendarEvent

    public CalendarEvent(int eventId, String name, String description, Date startDate, Date endDate, boolean canEdit)

  - ### CalendarEvent

    public CalendarEvent(int eventId, String name, String description, Date startDate, Date endDate, boolean canEdit, String eventWindowStyle)

  - ### CalendarEvent

    public CalendarEvent(int eventId, String name, String description, Date startDate, Date endDate, String lane)

  - ### CalendarEvent

    public CalendarEvent(int eventId, String name, String description, Date startDate, Date endDate, boolean canEdit, String eventWindowStyle, String lane)

  - ### CalendarEvent

    public CalendarEvent(int eventId, String name, String description, Date startDate, Date endDate, boolean canEdit, String eventWindowStyle, String lane, String sublane)

  - ### CalendarEvent

    public CalendarEvent(int eventId, String name, String description, Date startDate, int duration, TimeUnit durationUnit)

  - ### CalendarEvent

    public CalendarEvent(int eventId, String name, String description, Date startDate, int duration, TimeUnit durationUnit, String styleName)

  - ### CalendarEvent

    public CalendarEvent(int eventId, String name, String description, Date startDate, int duration, TimeUnit durationUnit, String styleName, String lane)

  - ### CalendarEvent

    public CalendarEvent(int eventId, String name, String description, Date startDate, int duration, TimeUnit durationUnit, String styleName, String lane, String sublane)

- ## Method Details

  - ### getOrCreateRef

    public static CalendarEvent getOrCreateRef(JavaScriptObject jsObj)

  - ### setBackgroundColor

    public CalendarEvent setBackgroundColor(String backgroundColor)
    An optional background color for the body portion of `canvases` representing this event in the various `calendar views`.

    Note that the recommended approach for styling events is to set a `custom CSS style`, which allows more complete customization of both header and body portions.

    Parameters:
      `backgroundColor` - New backgroundColor value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getBackgroundColor

    public String getBackgroundColor()
    An optional background color for the body portion of `canvases` representing this event in the various `calendar views`.

    Note that the recommended approach for styling events is to set a `custom CSS style`, which allows more complete customization of both header and body portions.

    Returns:
      Current backgroundColor value. Default value is null

  - ### setBorderColor

    public CalendarEvent setBorderColor(String borderColor)
    An optional border color for the body portion of `canvases` representing this event in the various `calendar views`.

    Note that the recommended approach for styling events is to set a `custom CSS style`, which allows more complete customization of both header and body portions.

    Parameters:
      `borderColor` - New borderColor value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getBorderColor

    public String getBorderColor()
    An optional border color for the body portion of `canvases` representing this event in the various `calendar views`.

    Note that the recommended approach for styling events is to set a `custom CSS style`, which allows more complete customization of both header and body portions.

    Returns:
      Current borderColor value. Default value is null

  - ### setCanDrag

    public CalendarEvent setCanDrag(Boolean canDrag)
    Optional boolean value controlling whether this event can be dragged with the mouse. The name of this field within the CalendarEvent can be changed via `Calendar.canDragEventField`. Only has an effect when `editing` is enabled.

    You can separately disallow drag-resize via `canResize`.

    Parameters:
      `canDrag` - New canDrag value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getCanDrag

    public Boolean getCanDrag()
    Optional boolean value controlling whether this event can be dragged with the mouse. The name of this field within the CalendarEvent can be changed via `Calendar.canDragEventField`. Only has an effect when `editing` is enabled.

    You can separately disallow drag-resize via `canResize`.

    Returns:
      Current canDrag value. Default value is null

  - ### setCanEditLane

    public CalendarEvent setCanEditLane(Boolean canEditLane)
    Boolean indicating whether this event can be moved between lanes. Can also be set at the `calendar level`.

    The name of this field within the CalendarEvent can be changed via `Calendar.canEditLaneField`.

    Parameters:
      `canEditLane` - New canEditLane value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getCanEditLane

    public Boolean getCanEditLane()
    Boolean indicating whether this event can be moved between lanes. Can also be set at the `calendar level`.

    The name of this field within the CalendarEvent can be changed via `Calendar.canEditLaneField`.

    Returns:
      Current canEditLane value. Default value is null

  - ### setCanEditSublane

    public CalendarEvent setCanEditSublane(Boolean canEditSublane)
    Boolean indicating whether this event can be moved between lanes. Can also be set at the `calendar level`.

    The name of this field within the CalendarEvent can be changed via `Calendar.canEditSublaneField`.

    Parameters:
      `canEditSublane` - New canEditSublane value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getCanEditSublane

    public Boolean getCanEditSublane()
    Boolean indicating whether this event can be moved between lanes. Can also be set at the `calendar level`.

    The name of this field within the CalendarEvent can be changed via `Calendar.canEditSublaneField`.

    Returns:
      Current canEditSublane value. Default value is null

  - ### setCanResize

    public CalendarEvent setCanResize(Boolean canResize)
    Optional boolean value controlling whether this event can be drag-resized with the mouse. The name of this field within the CalendarEvent can be changed via `Calendar.canResizeEventField`.

    Only has an effect if `editing` and `dragging` are also enabled.

    Parameters:
      `canResize` - New canResize value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getCanResize

    public Boolean getCanResize()
    Optional boolean value controlling whether this event can be drag-resized with the mouse. The name of this field within the CalendarEvent can be changed via `Calendar.canResizeEventField`.

    Only has an effect if `editing` and `dragging` are also enabled.

    Returns:
      Current canResize value. Default value is null

  - ### setDescription

    public CalendarEvent setDescription(String description)
    String which represents the description of a `CalendarEvent` The name of this field within the CalendarEvent can be changed via `Calendar.descriptionField`
    Parameters:
      `description` - New description value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getDescription

    public String getDescription()
    String which represents the description of a `CalendarEvent` The name of this field within the CalendarEvent can be changed via `Calendar.descriptionField`
    Returns:
      Current description value. Default value is null

  - ### setDisabled

    public CalendarEvent setDisabled(Boolean disabled)
    For a CalendarEvent that represents a `styled zone`, this attribute causes date-cells behind this zone to be disabled, meaning that events cannot be created or moved there with the mouse.
    Parameters:
      `disabled` - New disabled value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getDisabled

    public Boolean getDisabled()
    For a CalendarEvent that represents a `styled zone`, this attribute causes date-cells behind this zone to be disabled, meaning that events cannot be created or moved there with the mouse.
    Returns:
      Current disabled value. Default value is null

  - ### setDuration

    public CalendarEvent setDuration(Integer duration)
    The duration of this event. May be specified instead of an `end date` and implies that this is a "Period" type event. If set to zero, implies an "Instant" type event - an event with a start date but no length.
    Parameters:
      `duration` - New duration value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getDuration

    public Integer getDuration()
    The duration of this event. May be specified instead of an `end date` and implies that this is a "Period" type event. If set to zero, implies an "Instant" type event - an event with a start date but no length.
    Returns:
      Current duration value. Default value is null

  - ### setDurationUnit

    public CalendarEvent setDurationUnit(TimeUnit durationUnit)
    When a `duration` is set for this event, this is the unit of that duration. The default is minutes.
    Parameters:
      `durationUnit` - New durationUnit value. Default value is "minute"
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getDurationUnit

    public TimeUnit getDurationUnit()
    When a `duration` is set for this event, this is the unit of that duration. The default is minutes.
    Returns:
      Current durationUnit value. Default value is "minute"

  - ### setEndDate

    public CalendarEvent setEndDate(Date endDate)
    Date object which represents the end date of a `CalendarEvent` The name of this field within the CalendarEvent can be changed via `Calendar.endDateField`
    Parameters:
      `endDate` - New endDate value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getEndDate

    public Date getEndDate()
    Date object which represents the end date of a `CalendarEvent` The name of this field within the CalendarEvent can be changed via `Calendar.endDateField`
    Returns:
      Current endDate value. Default value is null

  - ### setEventWindowStyle

    public CalendarEvent setEventWindowStyle(String eventWindowStyle)
    Deprecated.
    in favor of `styleName`
    CSS style series to use for the draggable event window that represents this event. If specified, overrides `Calendar.eventWindowStyle` for this specific event.

    The name of this field within the CalendarEvent can be changed via `Calendar.eventWindowStyleField`

    Parameters:
      `eventWindowStyle` - New eventWindowStyle value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls
    See Also:
      - `CSSStyleName`

  - ### getEventWindowStyle

    public String getEventWindowStyle()
    Deprecated.
    in favor of `styleName`
    CSS style series to use for the draggable event window that represents this event. If specified, overrides `Calendar.eventWindowStyle` for this specific event.

    The name of this field within the CalendarEvent can be changed via `Calendar.eventWindowStyleField`

    Returns:
      Current eventWindowStyle value. Default value is null
    See Also:
      - `CSSStyleName`

  - ### setHeaderBackgroundColor

    public CalendarEvent setHeaderBackgroundColor(String headerBackgroundColor)
    An optional background color for the header portion of `canvases` representing this event in the various `calendar views`.

    Note that the recommended approach for styling events is to set a `custom CSS style`, which allows more complete customization of both header and body portions.

    Parameters:
      `headerBackgroundColor` - New headerBackgroundColor value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getHeaderBackgroundColor

    public String getHeaderBackgroundColor()
    An optional background color for the header portion of `canvases` representing this event in the various `calendar views`.

    Note that the recommended approach for styling events is to set a `custom CSS style`, which allows more complete customization of both header and body portions.

    Returns:
      Current headerBackgroundColor value. Default value is null

  - ### setHeaderBorderColor

    public CalendarEvent setHeaderBorderColor(String headerBorderColor)
    An optional border color for the header portion of `canvases` representing this event in the various `calendar views`.

    Note that the recommended approach for styling events is to set a `custom CSS style`, which allows more complete customization of both header and body portions.

    Parameters:
      `headerBorderColor` - New headerBorderColor value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getHeaderBorderColor

    public String getHeaderBorderColor()
    An optional border color for the header portion of `canvases` representing this event in the various `calendar views`.

    Note that the recommended approach for styling events is to set a `custom CSS style`, which allows more complete customization of both header and body portions.

    Returns:
      Current headerBorderColor value. Default value is null

  - ### setHeaderTextColor

    public CalendarEvent setHeaderTextColor(String headerTextColor)
    An optional text color for the header portion of `canvases` representing this event in the various `calendar views`.

    Note that the recommended approach for styling events is to set a `custom CSS style`, which allows more complete customization of both header and body portions.

    Parameters:
      `headerTextColor` - New headerTextColor value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getHeaderTextColor

    public String getHeaderTextColor()
    An optional text color for the header portion of `canvases` representing this event in the various `calendar views`.

    Note that the recommended approach for styling events is to set a `custom CSS style`, which allows more complete customization of both header and body portions.

    Returns:
      Current headerTextColor value. Default value is null

  - ### setLane

    public CalendarEvent setLane(String lane)
    When in Timeline mode, or when `Calendar.showDayLanes` is true, a string that represents the name of the `lane` this `CalendarEvent` should sit in. The name of this field within the CalendarEvent can be changed via `Calendar.laneNameField`.
    Parameters:
      `lane` - New lane value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getLane

    public String getLane()
    When in Timeline mode, or when `Calendar.showDayLanes` is true, a string that represents the name of the `lane` this `CalendarEvent` should sit in. The name of this field within the CalendarEvent can be changed via `Calendar.laneNameField`.
    Returns:
      Current lane value. Default value is null

  - ### setName

    public CalendarEvent setName(String name)
    String which represents the name of a `CalendarEvent` The name of this field within the CalendarEvent can be changed via `Calendar.nameField`
    Parameters:
      `name` - New name value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getName

    public String getName()
    String which represents the name of a `CalendarEvent` The name of this field within the CalendarEvent can be changed via `Calendar.nameField`
    Returns:
      Current name value. Default value is null

  - ### setStartDate

    public CalendarEvent setStartDate(Date startDate)
    Date object which represents the start date of a `CalendarEvent`. The name of this field within the CalendarEvent can be changed via `Calendar.startDateField`
    Parameters:
      `startDate` - New startDate value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getStartDate

    public Date getStartDate()
    Date object which represents the start date of a `CalendarEvent`. The name of this field within the CalendarEvent can be changed via `Calendar.startDateField`
    Returns:
      Current startDate value. Default value is null

  - ### setStyleName

    public CalendarEvent setStyleName(String styleName)
    CSS style series to use for `canvas instances` that represent this event in the various `calendar views`. The basic series should include three classes - the base style and others suffixed "Header" and "Body".

    If not specified on the event, the style can be specified on the `calendar`, the `view` or individually on each `lane` or `sublane`.

    The name of this field within the CalendarEvent can be changed via `Calendar.eventStyleNameField`

    Parameters:
      `styleName` - New styleName value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls
    See Also:
      - `CSSStyleName`

  - ### getStyleName

    public String getStyleName()
    CSS style series to use for `canvas instances` that represent this event in the various `calendar views`. The basic series should include three classes - the base style and others suffixed "Header" and "Body".

    If not specified on the event, the style can be specified on the `calendar`, the `view` or individually on each `lane` or `sublane`.

    The name of this field within the CalendarEvent can be changed via `Calendar.eventStyleNameField`

    Returns:
      Current styleName value. Default value is null
    See Also:
      - `CSSStyleName`

  - ### setSublane

    public CalendarEvent setSublane(String sublane)
    When in Timeline mode, or when `Calendar.showDayLanes` is true, a string that represents the name of the `sublane` this `CalendarEvent` should sit in. The name of this field within the CalendarEvent can be changed via `Calendar.sublaneNameField`.
    Parameters:
      `sublane` - New sublane value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getSublane

    public String getSublane()
    When in Timeline mode, or when `Calendar.showDayLanes` is true, a string that represents the name of the `sublane` this `CalendarEvent` should sit in. The name of this field within the CalendarEvent can be changed via `Calendar.sublaneNameField`.
    Returns:
      Current sublane value. Default value is null

  - ### setTextColor

    public CalendarEvent setTextColor(String textColor)
    An optional text color for the body portion of `canvases` representing this event in the various `calendar views`.

    Note that the recommended approach for styling events is to set a `custom CSS style`, which allows more complete customization of both header and body portions.

    Parameters:
      `textColor` - New textColor value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getTextColor

    public String getTextColor()
    An optional text color for the body portion of `canvases` representing this event in the various `calendar views`.

    Note that the recommended approach for styling events is to set a `custom CSS style`, which allows more complete customization of both header and body portions.

    Returns:
      Current textColor value. Default value is null

  - ### setUseLogicalTimes

    public CalendarEvent setUseLogicalTimes(Boolean useLogicalTimes)
    For a CalendarEvent that represents a `styled zone`, this attribute causes the Calendar to always display this zone at its specified logical-times, irrespective of the current day-range.
    Parameters:
      `useLogicalTimes` - New useLogicalTimes value. Default value is null
    Returns:
      `CalendarEvent` instance, for chaining setter calls

  - ### getUseLogicalTimes

    public Boolean getUseLogicalTimes()
    For a CalendarEvent that represents a `styled zone`, this attribute causes the Calendar to always display this zone at its specified logical-times, irrespective of the current day-range.
    Returns:
      Current useLogicalTimes value. Default value is null

  - ### setEventId

    public void setEventId(Integer eventId)

  - ### getEventId

    public Integer getEventId()

  - ### setCanEdit

    public void setCanEdit(Boolean canEdit)
    Optional boolean value controlling the editability of this particular calendarEvent. The name of this field within the CalendarEvent can be changed via `canEditField`.
    Parameters:
      `canEdit` - canEdit Default value is null

  - ### getCanEdit

    public Boolean getCanEdit()
    Optional boolean value controlling the editability of this particular calendarEvent. The name of this field within the CalendarEvent can be changed via `canEditField`.
    Returns:
      String